<template>
  <div class="chat-input-container">
    <div
      class="target-message-container slid-up-animation"
      v-if="
        chatInputStore.sendMessageFlag === 'replay' ||
        chatInputStore.sendMessageFlag === 'edit'
      "
      :class="{ 'dark-mode-bg': getCurrentThemeIsDark }"
    >
      <div class="close-container" @click="handleClose">
        <img src="/Images/tabs/close.svg" alt="icon" />
      </div>
      <!-- Target message selected -->
      <div class="target-message-info" :dir="rtlDesginHandler ? 'rtl' : 'ltr'">
        <span class="title" v-if="chatInputStore.sendMessageFlag === 'replay'">
          {{ $t('tabs.message.replayedto') }}
          {{ replayedMessageInformation.messageSenderName }}
        </span>
        <span class="title" v-if="chatInputStore.sendMessageFlag === 'edit'">
          {{ $t('tabs.message.editedmessage') }}
          {{ replayedMessageInformation.messageSenderName }}
        </span>
        <!-- <span
          class="title"
          v-if="chatInputStore.sendMessageFlag === 'send_image'"
        >
          {{ $t('tabs.message.sendimage') }}
        </span> -->
        <img
          style="width: 40px; height: 40px; margin: 5px 0"
          v-if="handleStickerAndImageReplyed"
          :src="handleStickerAndImageReplyed"
          alt="image"
        />
        <span
          class="message"
          v-if="chatInputStore.sendMessageFlag === 'replay'"
        >
          {{ selectedMessageInReplay }}</span
        >

        <span v-if="chatInputStore.sendMessageFlag === 'edit'">
          {{ selectedMessageInEdit }}
        </span>
      </div>
      <img
        src="/Images/tabs/replay-blue.svg"
        alt="image"
        v-if="chatInputStore.sendMessageFlag === 'replay'"
      />
      <img
        src="/Images/tabs/pencil-gray.svg"
        alt="image"
        v-if="chatInputStore.sendMessageFlag === 'edit'"
      />
    </div>
    <!-- Attchment items -->
    <div
      class="attach-menu-container slid-up-animation"
      v-if="filesMenu"
      :class="{ 'dark-mode-bg': getCurrentThemeIsDark }"
    >
      <div class="item">
        <div
          class="circle"
          @click="handleOpenImagesFile"
          style="background: rgb(108, 128, 219)"
        >
          <img
            style="width: 20px; height: 20px"
            src="/Images/tabs/gallery.svg"
            alt="image"
          />
        </div>
        <span>{{ $t('tabs.message.gallery') }}</span>
      </div>
      <div class="item">
        <div
          class="circle"
          @click="handleOpenFiles"
          style="background: #44dbfc"
        >
          <img
            style="width: 20px; height: 20px"
            src="/Images/tabs/file-white.svg"
            alt="image"
          />
        </div>
        <span>{{ $t('tabs.message.file') }}</span>
      </div>
      <div class="item">
        <div
          class="circle"
          @click="handleOpenVideosFile"
          style="background: #f8c615"
        >
          <img
            style="width: 20px; height: 20px"
            src="/Images/tabs/video-white.svg"
            alt="image"
          />
        </div>
        <span>{{ $t('tabs.message.video') }}</span>
      </div>
      <div class="item">
        <div
          class="circle"
          @click="handleOpenMussicsFile"
          style="background: #41e133"
        >
          <img
            style="width: 20px; height: 20px"
            src="/Images/tabs/music-white.svg"
            alt="image"
          />
        </div>
        <span>{{ $t('tabs.message.music') }}</span>
      </div>
      <div class="item">
        <div class="circle" style="background: #fc4465">
          <img
            style="width: 20px; height: 20px"
            src="/Images/tabs/location-white.svg"
            alt="image"
          />
        </div>
        <span>{{ $t('tabs.message.location') }}</span>
      </div>
    </div>

    <div class="chat-input" :class="{ 'dark-mode-bg': getCurrentThemeIsDark }">
      <div
        class="voice-recorder-container fade-animation"
        v-if="recordingStatus"
      >
        <div class="send-voice-btn">
          <img
            src="/Images/tabs/stop-red.svg"
            alt="icon"
            class="stop-recorder-btn"
          />
          <img
            src="/Images/tabs/send-message-white.svg"
            alt="icon"
            style="width: 35px; height: 35px"
            @click="sendVoice"
          />
        </div>
        <div class="timer-container">
          <img
            src="/Images/tabs/delete-red.svg"
            style="width: 20px; height: 20px"
            @click="cancelVoiceRecordingProccess"
            alt="icon"
          />
          <div class="timer">
            <span> 0{{ voiceRecordTimer.hours }} : </span>
            <span>
              <span v-if="voiceRecordTimer.minute < 10">0</span
              >{{ voiceRecordTimer.minute }} :
            </span>
            <span>
              <span v-if="voiceRecordTimer.second < 10">0</span>
              {{ voiceRecordTimer.second }}
            </span>
          </div>
        </div>
      </div>

      <div class="chat-items-container" v-else>
        <img
          @click="showEmojy = !showEmojy"
          src="/Images/tabs/emojies.svg"
          alt="icon"
          style="margin: 0px 15px"
        />
        <input
          :class="{ 'dark-mode-bg': getCurrentThemeIsDark }"
          name="chatInput"
          rows="1"
          cols="20"
          v-model="textMessage"
          class="input"
          :placeholder="t('tabs.message.chatInput.message')"
          dir="rtl"
          ref="input"
          @keyup.enter="handleSendMessage"
        />
        <img
          src="/Images/tabs/send-message-blue.svg"
          alt="icon"
          v-if="textMessage.length != 0"
          @click="handleSendMessage"
          style="margin: 0 10px"
        />
        <img
          @click="handlerOpenAttchmentItems"
          src="/Images/tabs/file.svg"
          alt="icon"
          style="margin: 0px 5px"
          v-if="
            textMessage.length == 0 &&
            chatInputStore.sendMessageFlag != 'send_image'
          "
        />
        <input
          type="file"
          ref="image"
          style="display: none"
          accept="image/*"
          @change="handlerSendImage($event.target)"
        />
        <input
          type="file"
          ref="file"
          style="display: none"
          accept=".txt,.zip,.xml,.pdf"
          @change="handlerSendFile($event.target)"
        />
        <input
          type="file"
          ref="video"
          style="display: none"
          accept="video/*"
          @change="handlerSendVideo($event.target)"
        />
        <input
          type="file"
          ref="mussic"
          style="display: none"
          accept="audio/*"
        />
        <img
          src="/Images/tabs/voice.svg"
          alt="icon"
          style="margin: 0px 10px"
          v-if="
            textMessage.length == 0 &&
            chatInputStore.sendMessageFlag != 'send_image'
          "
          @click="recordVoice"
        />
      </div>
    </div>

    <div class="stickers-container" v-if="showEmojy">
      <div class="active-tab-container">
        <EmojiPicker
          :hide-group-names="true"
          :disable-sticky-group-names="true"
          :disable-skin-tones="true"
          :hide-search="true"
          class="fade-animation"
          :native="true"
          :theme="getCurrentThemeIsDark ? 'dark' : 'light'"
          v-if="activeTab === 'emoji'"
          @select="onSelectEmoji"
        />
        <div class="fade-animation" v-if="activeTab === 'stickers'">
          <stickers />
        </div>
      </div>
      <div
        class="tabs-container"
        :class="{ 'dark-bg-tab': getCurrentThemeIsDark }"
      >
        <span
          @click="activeTab = 'stickers'"
          class="tab"
          :class="{ 'activer-tab': activeTab === 'stickers' }"
          >{{ t('tabs.message.chatInput.sticker') }}</span
        >
        <span
          @click="activeTab = 'emoji'"
          class="tab"
          :class="{ 'activer-tab': activeTab === 'emoji' }"
          >{{ t('tabs.message.chatInput.emoji') }}</span
        >
      </div>
    </div>
  </div>
</template>

<script setup>
import EmojiPicker from 'vue3-emoji-picker';
import stickers from '@/components/chats/stickers.vue';

import { fileUploader } from '@/api/file/index.js';
import { useFileManagerStore } from '@/store/fileManager/fileManager';
import { ref, watch, computed, defineEmits } from 'vue';
import { useChatInput } from '@/store/chats/chatInput.js';
import { useGroupChat } from '@/store/chats/groupChat.js';
import { useUserStore } from '@/store/user/user';
import { useI18n } from 'vue-i18n';
import { useThemeStore } from '@/store/theme.js';
import { generateUid } from '@/utils/generateUid.js';

const { t, locale } = useI18n();
const emit = defineEmits(['handleScroolToBottom']);
const themeStore = useThemeStore();
const fileManagerStore = useFileManagerStore();
const groupChatStore = useGroupChat();
const chatInputStore = useChatInput();
const userStore = useUserStore();
const textMessage = ref(chatInputStore.chatInputValue);
const recordingStatus = ref(false);
const showEmojy = ref(false);
const filesMenu = ref(false);
const activeTab = ref('emoji');
const voiceRecordTimer = ref({
  timer: false,
  hours: 0,
  minute: 0,
  second: 0,
});
const input = ref();
const image = ref();
const file = ref();
const video = ref();
const mussic = ref();

let recordedChunks = [];
let newAudio = null;
let recorder = null;

const rtlDesginHandler = computed(() => {
  {
    if (locale.value == 'fa') {
      return true;
    } else {
      return false;
    }
  }
});

const getCurrentThemeIsDark = computed(() => {
  return themeStore.getThemeIsDark;
});

const chatInputValueDataSource = computed(() => {
  return chatInputStore.chatInputValue;
});

const replayedMessageInformation = computed(() => {
  return chatInputStore.messageSenderInformation;
});

const selectedMessageInReplay = computed(() => {
  if (chatInputStore.messageSenderInformation.body.edit_state == 0) {
    if (chatInputStore.messageSenderInformation.message.length > 40) {
      return (
        chatInputStore.messageSenderInformation.message.slice(0, 40) + '...'
      );
    } else {
      return chatInputStore.messageSenderInformation.message;
    }
  } else {
    if (chatInputStore.messageSenderInformation.body.message.length > 40) {
      return (
        chatInputStore.messageSenderInformation.body.message.slice(0, 40) +
        '...'
      );
    } else {
      return chatInputStore.messageSenderInformation.body.message;
    }
  }
});

const handleStickerAndImageReplyed = computed(() => {
  return chatInputStore.messageSenderInformation.blob.filePath;
});

const selectedMessageInEdit = computed(() => {
  if (chatInputStore.messageSenderInformation.body.edit_state == 0) {
    if (chatInputStore.messageSenderInformation.message.length > 40) {
      return (
        chatInputStore.messageSenderInformation.message.slice(0, 40) + '...'
      );
    } else {
      return chatInputStore.messageSenderInformation.message;
    }
  } else {
    if (chatInputStore.messageSenderInformation.body.message.length > 40) {
      return (
        chatInputStore.messageSenderInformation.body.message.slice(0.4) + '...'
      );
    } else {
      return chatInputStore.messageSenderInformation.body.message;
    }
  }
});

watch(chatInputValueDataSource, (newValue, oldValue) => {
  textMessage.value = newValue;
});

const handlerOpenAttchmentItems = () => {
  filesMenu.value = !filesMenu.value;
};

const handleOpenImagesFile = () => {
  image.value.click();
  filesMenu.value = false;
};

const handleOpenFiles = () => {
  file.value.click();
  filesMenu.value = false;
};

const handleOpenVideosFile = () => {
  video.value.click();
  filesMenu.value = false;
};

const handleOpenMussicsFile = () => {
  mussic.value.click();
  filesMenu.value = false;
};

const handleSendMessage = async () => {
  input.value.focus();
  if (textMessage.value.trim() == '' || textMessage.value.trim().length == 0)
    return;
  let mtype = null;
  let clientObj = null;
  switch (chatInputStore.sendMessageFlag) {
    case 'send':
      mtype = 'grp.txt';
      clientObj = {
        time: new Date(),
        name: userStore.nickname,
        mtype: mtype,
        message: textMessage.value,
        from: userStore.userId,
        id: generateUid(50),
        firstChar: userStore.nickname.slice(0, 1).toUpperCase(),
        loading: true,
        body: { edit_state: 0, data: { ext_data: {} } },
      };
      groupChatStore.updateCurrentGroupMessageInClient(clientObj);
      break;
    case 'edit':
      const targetMessageInfo = chatInputStore.messageSenderInformation;
      const targetMessage = groupChatStore.currentGroup.messages.find(
        (message) => {
          return message.guid == targetMessageInfo.messageId;
        },
      );
      const newMessage = { ...targetMessage, loading: true };
      const detectIndex =
        groupChatStore.currentGroup.messages.indexOf(targetMessage);
      groupChatStore.handleReplaceItemForEdit(detectIndex, newMessage);
      mtype = 'grp.edt';
      clientObj = {
        mtype: mtype,
        group_id: groupChatStore.currentGroup.group_id,
        to: groupChatStore.currentGroup.group_id,
        id: generateUid(50),
        title: groupChatStore.currentGroup.title,
        message: textMessage.value,
        data: {
          editts: new Date().toString(),
          guid: chatInputStore.messageSenderInformation.messageId,
          mtype: 'grp.txt',
          nickname: userStore.nickname,
        },
      };
      break;
    case 'replay':
      mtype = 'grp.txt';
      clientObj = {
        name: userStore.nickname,
        mtype: mtype,
        message: textMessage.value,
        from: userStore.userId,
        id: generateUid(50),
        firstChar: userStore.nickname.slice(0, 1).toUpperCase(),
        loading: true,
        body: {
          edit_state: 0,
          data: {
            ext_data: {
              replyType: 3,
              replyDescription: chatInputStore.messageSenderInformation.message,
            },
          },
        },
      };
      groupChatStore.updateCurrentGroupMessageInClient(clientObj);
      break;
  }
  const result = {
    ...clientObj,
    ...groupChatStore.currentGroup,
    messageSenderInfo: chatInputStore.messageSenderInformation,
  };
  await chatInputStore.handleSendMessage(result);
  chatInputStore.clearChatInputValue();
  emit('handleScroolToBottom');
  textMessage.value = '';
};

const handleClose = () => {
  chatInputStore.clearMessageSenderInformation;
  chatInputStore.handleUpdateSendMessageFlag('send');
};

const handleRecordVoiceTimer = () => {
  voiceRecordTimer.value.timer = true;
  const timer = setInterval(() => {
    if (voiceRecordTimer.value.timer) {
      voiceRecordTimer.value.second++;
      if (voiceRecordTimer.value.second == 60) {
        voiceRecordTimer.value.second = 0;
        voiceRecordTimer.value.minute++;
      } else if (voiceRecordTimer.value.minute == 60) {
        voiceRecordTimer.value.minute = 0;
        voiceRecordTimer.value.hours++;
      }
    } else {
      voiceRecordTimer.value.timer = false;
      clearInterval(timer);
    }
  }, 1000);
};

const clearAndStopTimer = () => {
  voiceRecordTimer.value.timer = false;
  voiceRecordTimer.value.second = 0;
  voiceRecordTimer.value.minute = 0;
  voiceRecordTimer.value.hours = 0;
};

const onSelectEmoji = (emoji) => {
  textMessage.value += emoji.i;
};

// ** Send Voice Process **//
const recordVoice = async () => {
  recordingStatus.value = true;
  showEmojy.value = false;
  handleRecordVoiceTimer();
  newAudio = null;
  const stream = await navigator.mediaDevices.getUserMedia({
    audio: true,
    video: false,
  });
  const options = { mimeType: 'audio/webm' };
  recorder = new MediaRecorder(stream, options);
  recorder.addEventListener('dataavailable', async (e) => {
    if (e.data.size > 0) {
      recordedChunks.push(e.data);
    }
  });
  recorder.addEventListener('stop', async () => {});
  recorder.start();
};

const stopRecording = () => {
  clearAndStopTimer();
  recordingStatus.value = false;
  recorder.stop();
  recorder = null;
};

const sendVoice = async () => {
  stopRecording();
  setTimeout(async () => {
    let blob = new Blob(recordedChunks);
    const clientObj = {
      mtype: 'grp.aud',
      loading: true,
      from: userStore.userId,
      id: generateUid(50),
      firstChar: userStore.nickname.slice(0, 1).toUpperCase(),
      body: { edit_state: 0, data: { ext_data: {} } },
    };
    const result = new File([blob], 'Voice-Message.webm', {
      type: 'audio/webm',
    });
    groupChatStore.updateCurrentGroupMessageInClient(clientObj);
    await chatInputStore.handleSendVoice(result, clientObj.id);
  }, 100);
  emit('handleScroolToBottom');
};
// ** Send Voice Process **//

const handlerSendImage = async (event) => {
  chatInputStore.handleUpdateSendMessageFlag('send_image');
  const targetFile = event.files[0];
  chatInputStore.updateTargetImageFile(targetFile);
  const fileId = await fileUploader(chatInputStore.targetImageFile);
  const clientObj = {
    name: userStore.nickname,
    group_id: groupChatStore.currentGroup.group_id,
    mtype: 'grp.img',
    message: '',
    from: userStore.userId,
    id: generateUid(50),
    firstChar: userStore.nickname.slice(0, 1).toUpperCase(),
    loading: true,
    body: {
      mtype: 'grp.img',
      edit_state: 0,
      data: { fileId: fileId, ext_data: {} },
    },
  };
  groupChatStore.updateCurrentGroupMessageInClient(clientObj);
  chatInputStore.handleSendMessage(clientObj);
  emit('handleScroolToBottom');
};

const handlerSendFile = async (event) => {
  chatInputStore.handleSendFile(event.files[0]);
  emit('handleScroolToBottom');
};

const handlerSendVideo = async (event) => {
  chatInputStore.handleSendVideo(event.files[0]);
  emit('handleScroolToBottom');
};

const cancelVoiceRecordingProccess = () => {
  recordingStatus.value = false;
  stopRecording();
  clearAndStopTimer();
};
</script>

<style scoped>
.v3-emoji-picker {
  width: 100%;
  border-radius: 0;
  box-shadow: 0 0 0 0;
}
.chat-items-container {
  width: 100%;
  height: 60px;
  display: flex;
  align-items: center;
}

.voice-recorder-container {
  width: 100%;
  height: 60px;
  display: flex;
  align-items: center;
  justify-content: end;
}

.send-voice-btn {
  position: absolute;
  z-index: 1;
  display: flex;
  flex-direction: column;
  width: 80px;
  height: 85px;
  margin-top: -8px;
  margin-right: -15px;
  display: flex;
  justify-content: center;
  align-items: center;
  background: #0066ff;
  border-radius: 100px 90px 0 105px;
}

.timer-container {
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: start;
  padding: 0 10px;
}

.timer {
  padding: 0 15px;
  color: #979191;
  font-size: 14px;
}

@keyframes recorder-animation {
  0% {
    box-shadow: 10px 10px 10px 10px #7baaf1;
  }
  100% {
    box-shadow: 110px 150px 200px 150px #7baaf1;
  }
}

.attach-menu-container {
  width: 100%;
  height: 95px;
  background: #fff;
  display: flex;
  justify-content: center;
}

.attach-menu-container .item {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  margin: 0 7px;
}

.attach-menu-container .item span {
  font-size: 12px;
  font-weight: 600;
  color: #808080;
}

.circle {
  width: 40px;
  height: 40px;
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 50%;
  font-size: 22px;
  margin: 10px 10px;
}

.stop-recorder-btn {
  width: 30px;
  height: 30px;
  position: absolute;
  z-index: 1;
  margin-top: -130px;
}
.chat-input-container {
  width: 100%;
  display: flex;
  flex-direction: column;
  position: fixed;
  bottom: 0;
}
.target-message-container {
  width: 100%;
  display: flex;
  align-items: center;
  background: #fff;
  padding: 0 15px;
}
.target-message-container .target-message-info {
  width: 95%;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: start;
  padding: 0 10px;
}
.target-message-info .title {
  font-size: 16px;
  font-weight: 700;
  color: #428cff;
  padding: 5px 0;
}
.target-message-info .message {
  font-size: 14px;
  font-weight: 600;
}
.replay-status-container .close-container {
  width: 30px;
  height: 60px;
  display: flex;
  justify-content: center;
  align-items: center;
}
.chat-input {
  width: 100%;
  height: 55px;
  display: flex;
  align-items: center;
  background: #ecf0f8;
  justify-content: center;
  align-items: center;
  overflow: hidden;
}
.input {
  width: 77%;
  border: none;
  outline: none;
  background: #ecf0f8;
  margin: 0 5px;
}

.stickers-container {
  width: 100%;
  height: 350px;
  background: #fff;
  animation: 0.3s open-animation;
}

.active-tab-container {
  width: 100%;
  height: 300px;
  border-bottom: 1px solid #c2bdbd;
}

.tabs-container {
  width: 100%;
  height: 55px;
  display: flex;
  justify-content: center;
  align-items: center;
}

.tab {
  font-size: 14px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  color: #3f3c3c;
  margin: 0 10px;
  padding: 5px 5px;
  border-radius: 30px;
}

.activer-tab {
  background: #e6e3e3;
  color: #474545;
}

@keyframes open-animation {
  0% {
    height: 0;
  }
  100% {
    height: 360px;
  }
}

.dark-mode-bg {
  background: #333333;
}

.dark-bg-tab {
  background: #000000;
}
</style>
